// importing peasycam into processing, peasycam is used for manipualting the camera positions
import peasy.test.*;
import peasy.org.apache.commons.math.*;
import peasy.*;
import peasy.org.apache.commons.math.geometry.*;


// setting up PeasyCam
PeasyCam cam;

// including  ControlP5

import controlP5.*;
ControlP5 controlP5;
ControlP5 controlP5List;
ListBox l;

PMatrix3D currCameraMatrix;
PGraphics3D g3; 

// setting up fonts for text
PFont  myHelvetica10 = createFont("Helvetica",10, true);
PFont  myHelvetica12 = createFont("Helvetica",12, true);
PFont  myHelvetica16 = createFont("Helvetica",16, true);
PFont  myHelvetica20 = createFont("Helvetica",20, true);
PFont  myHelvetica24 = createFont("Helvetica",24, true);

color colForeground = 0xffaa0000;
color colBackground = 0xff660000;
color colActive = 0xffff0000;

//to store the data table
float [][][] dataMatrix = null;

int numWeekdays = 7;
int numWeeks = 52;
int numDewey = 10;

String[] weekdayNames = {
  "Sunday", 
  "Monday", 
  "Tuesday", 
  "Wednesday", 
  "Thursday", 
  "Friday", 
  "Saturday"
};

String[] deweyNames = {
  "1-100", 
  "100-200", 
  "200-300", 
  "300-400", 
  "400-500", 
  "500-600",
  "600-700", 
  "700-800", 
  "800-900", 
  "900-1000"   
};

float factDepth;
float morningShift;

int [][][] dataAwake = null;
int [][][] dataEarliestCout = null;
int [][][] dataLatestCout = null;
int maxAwake; //store max value
int numRowsGlobal = 3300;
int numRows;
int numCols = 8; //# of rows and columns of original data file

PFont myFont1 = createFont( "Helvetica", 24, true);
PFont myFont2 = createFont( "Helvetica", 16, true);

//  text formatting variables 
float constantMarginOnRows = 160;
float constantMarginOnColumns = 100;
Table myTable; 

float blockWidth = 40;
float blockHeight = 60;   // initial 80
float blockDepth = 35;

int p5Margin = 30;
int p5Distance = 22;

int buttonWidth = 150;
int buttonHeight = 20;

boolean textFlag= false;
boolean numberFlag = false;
boolean lineFlag = false; 

//int minimumNumber = 1;

// init values for interactivity PARAMS:
int transparency = 64;
int alpha;

float pHeight = 0;
float pWidth = 0;
float pDepth = 1;

float xPos = -5;
float yPos = 10;
float zPos = -36;

int deweySelect = 1; 
