
void drawGUI() 
      {
        currCameraMatrix = new PMatrix3D(g3.camera);
        camera();
        controlP5.draw();
        g3.camera = currCameraMatrix;
      }


void setupGUI()
      {        
              controlP5= new ControlP5(this);
              
                controlP5.setColorForeground(colForeground);
                controlP5.setColorBackground(colBackground);
                controlP5.setColorLabel(0xffdddddd);
                controlP5.setColorValue(color(220));//(0xffff88ff);
                 controlP5.setColorActive(colActive);
              controlP5.setFont(myHelvetica12);
              controlP5.setColorLabel(color(255,128));
              //controlP5.setBackground(color(40));
              //controlP5.setColorBackground(s2DbuttonBackCol);
              //controlP5.setColorForeground(s2DbuttonForeCol);
              controlP5.setColorCaptionLabel(color(220));
             Tab theParent;
              Toggle t1 = controlP5.addToggle("Labels",false,  p5Margin, p5Margin + 2 * p5Distance , buttonWidth , buttonHeight) ;  
              t1.setLabel("Labels");
        controlP5.Label lt1 = t1.captionLabel();
lt1.style().marginTop = -23; //move upwards (relative to button size)
lt1.style().marginLeft = 2; //move to the right
              //controlP5.addToggle("Text Flag",  p5Margin, p5Margin + 2 * p5Distance , buttonWidth , buttonHeight) ;             
             // controlP5.addToggle("Number Flag",p5Margin, p5Margin + 3 * p5Distance , buttonWidth , buttonHeight) ;           
              Toggle t = controlP5.addToggle("Awake Times",false, p5Margin, p5Margin + 3 * p5Distance , buttonWidth , buttonHeight) ;
                   t.setLabel("Awake Times");
        controlP5.Label lt = t.captionLabel();
lt.style().marginTop = -23; //move upwards (relative to button size)
lt.style().marginLeft = 2; //move to the right           
              //controlP5.addToggle("Line Flag",p5Margin, p5Margin + 4 * p5Distance , buttonWidth , buttonHeight) ;                                    
              Slider sAlpha = controlP5.addSlider("alpha", (int)255*0.2  ,(int)255*0.8 ,transparency ,p5Margin, p5Margin + 4 * p5Distance , buttonWidth , buttonHeight) ;
              
              controlP5.Label sAlphaLabel = sAlpha.captionLabel();
              sAlphaLabel.style().marginLeft = -45; //move horizontally 
              
              //block distance and layer perspective sliders
               // add blank button for heading
                controlP5.addButton("Layer distance & perspective")
                .setPosition(p5Margin+1200-30, p5Margin + 680)
                .setSize(0 , buttonHeight)
                .setColorBackground(color(255))
                .setColorForeground(color(255))
                .setColorCaptionLabel(color(1));
              
              Slider sPerspX = controlP5.addSlider("pHeight" ,-25 ,25,p5Margin+1200, p5Margin + 680+ p5Distance , buttonWidth , buttonHeight) ;
              Slider sPerspY = controlP5.addSlider("pWidth" ,-25 ,25 ,p5Margin+1200, p5Margin + 680+ 2*p5Distance , buttonWidth , buttonHeight) ;
              Slider sPerspZ = controlP5.addSlider("pDepth" ,1 ,25 ,p5Margin+1200, p5Margin + 680+ 3*p5Distance , buttonWidth , buttonHeight) ;
              
              controlP5.Label sPerspLabelX = sPerspX.captionLabel();
              controlP5.Label sPerspLabelY = sPerspY.captionLabel();
              controlP5.Label sPerspLabelZ = sPerspZ.captionLabel();
              sPerspLabelX.style().marginLeft = -61; //move horizontally 
              sPerspLabelY.style().marginLeft = -61; //move horizontally 
              sPerspLabelZ.style().marginLeft = -61; //move horizontally                
              
              //three dimensional panning sliders
               // add blank button for heading
                controlP5.addButton("3D Panning")
                .setPosition(p5Margin+30, p5Margin + 680)
                .setSize(0 , buttonHeight)
                .setColorBackground(color(255))
                .setColorForeground(color(255))
                .setColorCaptionLabel(color(1));
              Slider sPanning = controlP5.addSlider("xPos" ,-100 ,100,p5Margin, p5Margin + 680+ p5Distance , buttonWidth , buttonHeight) ;
              //sPanning.setLabel("xPos");
        controlP5.Label sPanningLabel = sPanning.captionLabel();
//sPanningLabel.style().marginTop = 1; //move upwards (relative to button size)
sPanningLabel.style().marginLeft = -42; //move horizontally   

              Slider sPanningY = controlP5.addSlider("yPos" ,-50 ,50 ,p5Margin, p5Margin + 680+ 2*p5Distance , buttonWidth , buttonHeight) ;
              Slider sPanningZ = controlP5.addSlider("zPos" ,-150 ,50 ,p5Margin, p5Margin + 680+ 3*p5Distance , buttonWidth , buttonHeight) ;
              //controlP5.addButton("Number Flag",1.0 , p5Margin, p5Margin + 3 * p5Distance , buttonWidth , buttonHeight) ; 
              
              controlP5.Label sPanningLabelY = sPanningY.captionLabel();
              controlP5.Label sPanningLabelZ = sPanningZ.captionLabel();
              sPanningLabelY.style().marginLeft = -42; //move horizontally 
              sPanningLabelZ.style().marginLeft = -42; //move horizontally   
              
              //controlP5List.setColorLabel(color(1,128));
              //controlP5List.setColorCaptionLabel(color(1));
              //ListBox l;
              l = controlP5.addListBox("myList")
                 .setPosition(p5Margin+1200, p5Margin + 3 * p5Distance)
                 .setSize(buttonWidth,buttonWidth)
                 .setItemHeight(14)
                 .setBarHeight(buttonHeight)
                 .setColorActive(colActive)
                 .setColorForeground(colForeground)
                 .setColorBackground(colBackground)
                 ;

                  l.captionLabel().toUpperCase(true);
                  l.captionLabel().set("Select Dewey Class");
                  //l.captionLabel().setColor(0xffff0000);
                  l.captionLabel().style().marginTop = 3;
                  l.valueLabel().style().marginTop = 3;
  
                  for (int i=0;i<numDewey;i++) {
                    ListBoxItem lbi = l.addItem(deweyNames[i], i);
                    //lbi.setColorBackground(0xffff0000);
                    //l.setValue(i);
                    if (i==deweySelect){lbi.setColorBackground(colActive);}
                  }
              
              
              controlP5.setAutoDraw(false);
        }  


void controlEvent(ControlEvent theEvent) 
                {
  
                 
                if(theEvent.isController()) 
                  {
              
                  if(theEvent.controller().name()=="Labels") {
                                                                          if(theEvent.controller().value()==1)
                                                                             {
                                                                               textFlag = true;
                                                                             }
                                                                           else
                                                                             {
                                                                               textFlag = false;                                                                       
                                                                             }                                                                               
                                                                       
                                                                    }
                                                                   
                                                                          
                   if(theEvent.controller().name()=="Awake Times") {
                                                                           if(theEvent.controller().value()==1)
                                                                             {
                                                                               numberFlag = true;
                                                                             }
                                                                           else
                                                                             {
                                                                               numberFlag = false;                                                                       
                                                                             }                                                                             
                                                                          }     
                  
      
                    
                   if(theEvent.controller().name()=="alpha") {
                                                                    transparency = int ( theEvent.controller().value() ) ;
                                                                    }     
               
                   if(theEvent.controller().name()=="pHeight") {
                                                                    pHeight = int ( -theEvent.controller().value() ) ;
                                                                    }     
               
                    if(theEvent.controller().name()=="pWidth") {
                                                                    pWidth = int ( theEvent.controller().value() ) ;
                                                                    }     
                    
                    if(theEvent.controller().name()=="pDepth") {
                                                                    pDepth = int ( theEvent.controller().value() ) ;
                                                                    }  
                    if(theEvent.controller().name()=="xPos") {
                                                                    xPos = int ( theEvent.controller().value() ) ;
                                                                    }     
               
                    if(theEvent.controller().name()=="yPos") {
                                                                    yPos = int ( theEvent.controller().value() ) ;
                                                                    }     
                    
                    if(theEvent.controller().name()=="zPos") {
                                                                    zPos = int ( theEvent.controller().value() ) ;
                                                                    }  
                                                                 
                   //if(theEvent.controller().name()=="myList") {
                   //                                                 deweySelect = int ( theEvent.controller().value() ) ;
                   //                                                 }   
    /*                                          
                    if(theEvent.controller().name()=="View 1") {
                                                                 
                                                                 cam.lookAt(0,0,0,2800,3000);
                                                                  }        
                    */
                                                                                
                  
                  print("control event from : "+theEvent.controller().name());
                  println(", value : "+theEvent.controller().value());
                  
                    }
    
    if (theEvent.isGroup()) {
    // an event from a group e.g. scrollList
    println(theEvent.group().value()+" from "+theEvent.group());
  }
  
  //   if(theEvent.isGroup() && theEvent.name().equals("myList")){
//    deweySelect = int ( theEvent.value() );
//    println("deweyClass: "+deweySelect);
//  } 
   
   //code block to highlight selected item in dewey scroll list                                       
   if(theEvent.name().equals("myList")){
    int currentIndex = (int)theEvent.group().value();
    println("oldDewey select:  "+deweySelect);
    if(deweySelect >= 0){//if something was previously selected
      l.getItem(deweySelect).setColorBackground(colBackground);
      //ListBoxItem previousItem = l.getItem(deweySelect);//get the item
      //println(previousItem.getColorBackground());
      //previousItem.setColorBackground(colBackground);//and restore the original bg colours
    }
    deweySelect = currentIndex;//update the selected index
    println("new Dewey select:  "+deweySelect);
    l.getItem(deweySelect).setColorBackground(colActive);//and set the bg colour to be the active/'selected one'...until a new selection is made and resets this, like above
   }               
             
}

//TODO:
// label on left side for hours --> title: darker means longer awake time, hours in y dimension, weeks in x dimension
// boxes/frames for months / weeks
// replace dewey layers with (select) itemtype layers
// add colorbar
